#include <gtk/gtk.h>
#include "goom_xmms.h"

static GtkWidget *about_window = NULL;

static void close_cb(GtkWidget *w, gpointer data)
{
	gtk_widget_destroy(about_window);
	about_window = NULL;
}

void about()
{
	GdkFont *font;
	GtkWidget *vbox, *scroll, *text, *bbox, *btn;

	/* If already showing the window, do nothing */
	if (about_window)
		return;

	/* Create a new window */
	about_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_container_border_width(GTK_CONTAINER(about_window), 10);
	gtk_window_position(GTK_WINDOW(about_window), GTK_WIN_POS_MOUSE);

	/* Create a vbox inside the window */
	vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_add(GTK_CONTAINER(about_window), vbox);

	/* Create a scrolled window in the vbox */
	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start(GTK_BOX(vbox), scroll, FALSE, FALSE, 0);

	/* Create a text widget in the scrolled window */
	text = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(text, 400, 250);
	gtk_container_add(GTK_CONTAINER(scroll), text);

	/* Stuff the text into it, using the Courier font */
	font = gdk_font_load("-*-courier-medium-r-normal--*-120-*-*-*-*-*-*");
	gtk_text_insert(GTK_TEXT(text), font, NULL, NULL, readme, -1);
	gdk_font_unref(font);
	gtk_text_set_editable(GTK_TEXT(text), FALSE);

	/* Create a button box under the text widget */
	bbox = gtk_hbutton_box_new();
	gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(bbox), 5);
	gtk_box_pack_start(GTK_BOX(vbox), bbox, FALSE, FALSE, 0);

	/* Add a [Close] button */
	btn = gtk_button_new_with_label("Close");
	gtk_signal_connect_object(GTK_OBJECT(btn), "clicked", GTK_SIGNAL_FUNC(close_cb), GTK_OBJECT(about_window));
	GTK_WIDGET_SET_FLAGS(btn, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(bbox), btn, TRUE, TRUE, 0);
	gtk_widget_grab_default(btn);

	/* Show everything */
	gtk_widget_show(btn);
	gtk_widget_show(bbox);
	gtk_widget_show(text);
	gtk_widget_show(scroll);
	gtk_widget_show(vbox);
	gtk_widget_show(about_window);
}
