#include "ifs.h"

void ifs_update (guint32 *data, int width, int height, int increment)
{
  static int couleur = 0xc0c0c0c0;
  static int v[4] = {2,4,3,2};
  static int col[4] = {2,4,3,2};
#define MOD_MER 0
#define MOD_FEU 1
  static int mode = MOD_MER;
  
  int nbpt;
  IFSPoint *points;
  int i;

  points = draw_ifs (&nbpt);

  for (i = 0; i < nbpt; i+=increment) {
    int x = (int)points[i].x & 0x7fffffff;
    int y = (int)points[i].y & 0x7fffffff;
    if ((x < width) && (y < height)) {
      int pos = x + (int)(y * width);
//      int dat = data [pos];
      data [pos] = couleur;//((dat&0xfefefefe) + (couleur & 0xfefefefe)) >> 1;
    }
  }
  
  col[0] = (couleur & 0xff000000) >> 24;
  col[1] = (couleur & 0x00ff0000) >> 16;
  col[2] = (couleur & 0x0000ff00) >> 8;
  col[3] = (couleur & 0x000000ff);

  if (mode == MOD_MER) {
	col[BLEU] += v[BLEU];
	if (col[BLEU]>255) {
	  col[BLEU]=255; v[BLEU] = - (rand () % 4) - 1;
	}
	if (col[BLEU]<32) {
	  col[BLEU]=32; v[BLEU] = (rand () % 4) + 1;
	}
	
	col[VERT] += v[VERT];
	if (col[VERT]>200) {
	  col[VERT]=200; v[VERT] = - (rand () % 3) - 2;
	}
	if (col[VERT]>col[BLEU]) {
	  col[VERT]=col[BLEU]; v[VERT] = - (rand () % 3) - 2;
	}
	if (col[VERT]<32) {
	  col[VERT]=32; v[VERT] = (rand () % 3) + 2;
	}
	
	col[ROUGE] += v[ROUGE];
	if (col[ROUGE]>64) {
	  col[ROUGE]=64; v[ROUGE] = - (rand () % 4) - 1;
	}
	if (col[ROUGE]<0) {
	  col[ROUGE]=0; v[ROUGE] = (rand () % 4) + 1;
	}

	if ((col [VERT] > 32) && (col[ROUGE]<col[VERT] + 40) && (col[VERT]<col[ROUGE] + 20) && (col [BLEU] < 64)
		&& (rand () % 20 == 0))
	  mode = MOD_FEU;
  }
  else if (mode == MOD_FEU) {

	col[BLEU] += v[BLEU];
	if (col[BLEU]>64) {
	  col[BLEU]=64; v[BLEU] = - (rand () % 4) - 1;
	}
	if (col[BLEU]<0) {
	  col[BLEU]=0; v[BLEU] = (rand () % 4) + 1;
	}
	
	col[VERT] += v[VERT];
	if (col[VERT]>200) {
	  col[VERT]=200; v[VERT] = - (rand () % 3) - 2;
	}
	if (col[VERT]>col[ROUGE] + 20) {
	  col[VERT]=col[ROUGE] + 20; v[VERT] = - (rand () % 3) - 2;
	  v[ROUGE] = (rand () % 4) + 1; v[BLEU] = (rand () % 4) + 1;
	}
	if (col[VERT]<0) {
	  col[VERT]=0; v[VERT] = (rand () % 3) + 2;
	}
	
	col[ROUGE] += v[ROUGE];
	if (col[ROUGE]>255) {
	  col[ROUGE]=255; v[ROUGE] = - (rand () % 4) - 1;
	}
	if (col[ROUGE]>col[VERT]+40) {
	  col[ROUGE]=col[VERT]+40; v[ROUGE] = - (rand () % 4) - 1;
	}
	if (col[ROUGE]<0) {
	  col[ROUGE]=0; v[ROUGE] = (rand () % 4) + 1;
	}

	if ((col [ROUGE] < 64) && (col [VERT] > 32) && (col [VERT] < col [BLEU]) && (col [BLEU] > 32)
		&& (rand () % 20 == 0))
	  mode = MOD_MER;
  }

  col[ALPHA] += v[ALPHA];
  if (col[ALPHA]>0) {
	col[ALPHA]=0; v[ALPHA] = - (rand () % 4) - 1;
  }
  if (col[ALPHA]<0) {
	col[ALPHA]=0; v[ALPHA] = (rand () % 4) + 1;
  }
  
  couleur = (col[0]<<24)|(col[1]<<16)|(col[2]<<8)|(col[3]);
}
