#include "pixeldoubler.h"

void pixel_doubler (Surface *src, Surface *dest) {
  register int32 *d; // pointeur sur le pixel courant a marquer
  register int32 *s; // pointeur sur le pixel coutant en cours de lecture
  int32 sw;  // nombre d'octet de largeur du ligne de la surface source
  int32 fd;  // adresse de la fin du buffer destination
  int32 fin; // adresse de fin d'une ligne du buffer source

  d = dest->buf;
  s = src->buf;

  sw = src->width << 2;

  fin = (int32)s;
  fd = (int32)d + (dest->size<<2);
  
  // tant que tout le buffer source n'est pas remplit
  while ((int32)d < fd) {

    // passer a la ligne suivante du buffer source
    fin += sw;

    // l'afficher sur une ligne du buffer destination
    while ((int32)s < fin) {
      register int32 col = *(s++);
      // 2 affichage par point du buffer source (doubling horizontal)
      *(d++) = col; *(d++) = col;
    }

    // puis l'afficher sur une autre ligne (doubling vertical)
    s = (int32*)((int32)s - sw); // retour au debut de la ligne src
    while ((int32)s < fin) {
      register int32 col = *(s++);
      *(d++) = col; *(d++) = col; // idem (cf plus haut)
    }
  }
}
