#include "config.h"

#define DISPLAY_IT
#undef DISPLAY_IT

#include <stdlib.h>
#include <glib.h>
#include "tinyptc.h"
#include <math.h>

#include "goom_tools.h"
#include "goom_core.h"

#define WIDTH 400
#define HEIGHT 300

#define NB_COUNT 150
#define PROCSPEED 800000000.0f

int main ()
{
  gint16 data [2][512];
  GTimer * timer;
  static int count = 0;
	  int i;

#ifdef DISPLAY_IT
  /* ouverture */
  if (!ptc_open("What a GOOM!",WIDTH,HEIGHT))
	exit (1);
#endif
  
  goom_init (WIDTH, HEIGHT);
  timer = g_timer_new ();
  g_timer_start (timer);

		  for (i = 0; i < 512 ; i++)
			{
			  data [0][i] = 0 ;
			  data [1][i] = 0 ;
			}
  
  while (1)
	{
	  static int monbool;


	  count ++;
	  if (count == NB_COUNT)
	  {
			  gdouble tps ;
			  tps = g_timer_elapsed (timer, NULL);
			  printf ("%f secondes pour %d images.\nSoit %3.2f fps.\n",
					  tps, NB_COUNT, (float)NB_COUNT/tps);
			  count = 0;
			  printf ("CLOCKS PAR PIXELS = %4.1f\n",
					  (double)PROCSPEED * tps / (NB_COUNT * WIDTH * HEIGHT));
			  // ((double)NB_COUNT * WIDTH * HEIGHT) / (tps * PROCSPEED));
			  g_timer_reset (timer);
	  }

#ifdef DISPLAY_IT
	  if (rand () % 25 == 0)
		{
		  monbool = rand () % 2;
		}

	  if (monbool)
		{
		  for (i = 0; i < 512 ; i++)
			{
			  data [0][i] = rand ();
			  data [1][i] = rand ();
			}
		}
	  else
		{
		  for (i = 0; i < 512 ; i++)
			{
			  data [0][i] = 0 ;
			  data [1][i] = 0 ;
			}
		}
#endif

#ifdef DISPLAY_IT
	  ptc_update (goom_update (data));
#else
	  goom_update (data);
#endif
/*	  if (rand () % 100 == 0)
	  {
			  int x,y;
			  ptc_close ();
			  x = rand () % WIDTH + 50;
			  y = rand () % HEIGHT + 50;
			  ptc_open ("zzz", x,y);
			  goom_set_resolution (x,y);
	  }
*/	}

g_timer_stop (timer);
g_timer_destroy (timer);

	
  /* fermeture */
  ptc_close();
  goom_close ();
}
