/*
 * 
 * TinyPTC x11 v0.5.1 ported by Alessandro Gatti (a.gatti@tiscalinet.it)
 * Original Windows version by Glenn Fiedler (ptc@gaffer.org)
 * http://www.gaffer.org/tinyptc
 *
 */

#ifndef __TINYPTC_X11
#define __TINYPTC_X11

#define __PTC_XSHM__
#define __PTC_WINDOWED__
#define __PTC_ENABLE_CONVERSIONS__
#define __PTC_MMX__

#define __PTC_BEST_VIDEOMODE__
#define __PTC_LITTLE_ENDIAN__
//#define __PTC_CLEANUP_CALLBACK__

typedef unsigned int int32;
typedef unsigned short int16;
typedef unsigned short short16;
typedef unsigned char char8;

/* To chose a videomode for fullscreen.
 * return -1 if not success : a VideoModeNumber else
 */
int ptc_get_nearest_mode (int width, int height, int*nwidth, int *nheight);

extern int ptc_open(char *title, int width, int height,
					int fullscreen);
extern int ptc_update(void *buffer);
extern void ptc_close(void);
int ptc_process_events(void);

int ptc_escape_pressed ();
int ptc_key_pressed (char c);
int ptc_f1_pressed ();
int ptc_f2_pressed ();
int ptc_f3_pressed ();
int ptc_f3_pressed ();
int ptc_f4_pressed ();
int ptc_f5_pressed ();
int ptc_f6_pressed ();
int ptc_f7_pressed ();
int ptc_f8_pressed ();

int ptc_is_open ();

#endif /* __TINYPTC_X11 */
