/*
 * 
 * TinyPTC x11 v0.5 ported by Alessandro Gatti (a.gatti@tiscalinet.it)
 * Original Windows version by Glenn Fiedler (ptc@gaffer.org)
 * http://www.gaffer.org/tinyptc
 * 
 */

#include "tinyptc.h"

/* Common #defines */

#define __PTC_FUNCTION_KEY__ 0xFF
#define __PTC_ESCAPE_KEY__ 0x1B

/* #includes */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <glib.h> 
#include <xmms/dga.h>

//Display *ptc_display ;
xmms_dga_info_t ptc_dga_info ;
int ptc_width, ptc_height ;

/* Open the screen */

int
ptc_open (char *title, int width, int height)
{
//	ptc_display = XOpenDisplay (NULL);
//	if (ptc_display == NULL)
//	{
//		return 0;
//	}

//	printf ("initializing ptc_dga\n") ;
//	if (!xmms_dga_init (ptc_display)) {
//		printf ("couldn't init dga\n") ;
//	}
	ptc_dga_info.width=320 ;
	ptc_dga_info.height=240 ;
	ptc_dga_info.bytes_per_pixel=4 ;
	
	if (xmms_dga_available ()) {
			printf ("dga is available\n") ;
/*	}
	else {*/
			printf ("setting dga\n") ;
			if (!xmms_dga_enter (&ptc_dga_info)) {
				printf ("could not set dga\n") ;
				return 0 ;
			}
	}
	
	printf ("testing dga\n") ;
	if ( (ptc_dga_info.width < width)
		|| (ptc_dga_info.height < height)
		|| (ptc_dga_info.bytes_per_pixel!=4) ) {
			printf ("wrong size...\n") ;
			return (0) ;
	}
	
	ptc_width = width ;
	ptc_height = height ;
	
	return 1;
}

/* Update the screen */

int
ptc_update (void *buffer)
{
	xmms_dga_draw_32_image (0,0,ptc_width, ptc_height, buffer, ptc_width*4) ;

	return (1);
}

/* Process events */

int
ptc_process_events (void)
{
}

/* Close the screen */

void
ptc_close (void)
{
	xmms_dga_leave () ;
}
